// $Id: WILL_Helpers.js,v 1.20 2006/01/13 23:08:33 Will Exp $

//////////////////////
// Helper functions //
//////////////////////
var WILL_helperDefined=true;

// Incremented automatically by the release script - WILL: I don't think it is incremented!
// - used by build script to update install.rdf
var VIEWMYCURRENCY_VERSION = 0.38; 

var WILL_gDebug=3; // default to logging everything. overridden by preference WILL: TODO: investigate if this works in other chrome windows

function WILL_shortenStr(str,max) {
  if (!str) { str='null'; }
  str=str.replace(/\n/g,' '); //keep it on one line
  return (str.length>max) ? str.substr(0,max-3)+'...' : str;
}

function WILL_ge(id,failSilently) {
  var element=window.document.getElementById(id);
  if (!element && !failSilently) { WILL_alert('Failed to find GUI element '+id); }
  return element;
    
}

function WILL_killChildren(n) {
  while (n.firstChild) { n.removeChild(n.firstChild); }
}


var gConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function WILL_log(level,message) {
  if (!level) { WILL_alert('level not set for '+message); }
  var d=WILL_gDebug;
  
  var label=null;
  var makeExcp=false;
  switch(level) {
 case 'DBG3':
    if (d>2) { label='DEBUG3: WILL: '+message; }
    break; 
 case 'DBG':
    if (d>1) { label='DEBUG: WILL: '+message; }
    break;
  case 'INFO':
    if (d>0) { label='INFO: WILL: '+message; }
    break;
  case 'WARN':
    label='--- WARNING: WILL: '+message + WILL_getStackTrace();
    break;
  case 'ERR':
    label='------ERROR: WILL: '+message + WILL_getStackTrace();
    if (d>0) {
      makeExcp=true; //only generate an exception if we are in debug mode
    }
    break;
  default:
    WILL_alert('unknown level '+level+' set for '+message); 
  }
  if (label) {
    gConsoleService.logStringMessage(label);
    if (makeExcp) { throw label; }
  }

}

function WILL_getStackTrace() {
  if (!WILL_gDebug) { return ''; }

  var trace;
  try {throw new Error(); } catch (e) {trace = e.stack; }
  var lines = trace.split('\n');

  //remove the first three lines (ingore trace into error funcs)
  lines.reverse();
  lines.pop();   lines.pop();  lines.pop();
  lines.reverse();

  trace=lines.join('\n');

  return '\n'+
    '---------------------------- Stack Trace -----------------------------\n'+
    trace + '\n'+
    '----------------------------------------------------------------------\n';

}
  
function WILL_alert(message) {
  var label = message+'\n'+WILL_getStackTrace();
  alert('ViewMyCurrency: '+ label);
}

function WILL_dbg(o) {
  var s = "";
  var i = 0;

  for (var p in o) {
    s += p + ":" + o[p] + "\n";

    if (++i % 30 === 0) {
      alert(s);
      s = "";
    }
  }

  alert(s);
}

//WILL: Useful constructor code for giving pseudo-unique IDs to each object
//   this.__id = Math.round(Math.random()*100);
//   dump('Created new '+this.__proto__.constructor.name+' # '+this.__id+'\n');
//   this.toString = function() { return this.__proto__.constructor.name + '#'+this.__id; };
