// $Id: WILL_OptionsDialogManager.js,v 1.7 2006/01/06 11:35:51 Will Exp $

var WILL_optionsManager;


function WILL_OptionsDialogLoad() {
  // we could be called from Extensions Options or directly from my own gui. So can't rely on window.arugments
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
    .getService(Components.interfaces.nsIWindowMediator);
  var browserWindow = wm.getMostRecentWindow("navigator:browser");

  //WILL: TODO: fix nasty hack! There must be a better way to do this?
  var prefMan =           browserWindow.WILL_gViewMyCurrencyGui._viewMyCurrency.prefManager;
  var exchangeRateCache = browserWindow.WILL_gViewMyCurrencyGui._viewMyCurrency.exchangeRateCache;

  WILL_optionsManager = new WILL_OptionsDialogManager(prefMan,exchangeRateCache);
}


//WILL: these comments are out of date!
// this works without seeing the main ViewMyCurrency object - it just gets/sets the prefs
// this requires ViewMyCurrency to use watchers to detect and act on the changes
// Advantages: PrefManager doesn't depend on ViewMyCurrency
//             Prefs can be safely edited in about:config 
//             Everything stays in sync if a new application window is started (with Control-N for example)
function WILL_OptionsDialogManager(prefManager,exchangeRateCache) {

  this.prefManager=prefManager;

  this._init = _init;
  //functions
  this.guiDebugLevelChanged     = guiDebugLevelChanged;
  this.doButtonModifyTargetList = doButtonModifyTargetList;
  this.doButtonModifySourceList = doButtonModifySourceList;
  this.doButtonOK               = doButtonOK;
  this.doButtonCancel           = doButtonCancel;
  this.doButtonResetAll         = doButtonResetAll;
  this.doButtonDeletePrefs      = doButtonDeletePrefs;


  this.prefManager         = prefManager;
  this.exchangeRateCache   = exchangeRateCache;
  this._webUpdater         = exchangeRateCache.webUpdater;

  this.mouseClick          = mouseClick;
  this.buttonUpdate        = buttonUpdate;
  this.changeWebServiceUrl = changeWebServiceUrl;

  this.observe             = observe;
  this.die                 = die;

  this._initTable        = _initTable;
  this._setTextBoxes     = _setTextBoxes;
  this._mouseClickOnCell = _mouseClickOnCell;

  this._sourceListDirty = false;
  this._targetListDirty = false;
  this._completeListDirty = false;

  this._init();
  this._initTable();

  this.exchangeRateCache.webUpdater.addObserver(this);

  if (!this.prefManager) {WILL_alert('this window cannot be run standlone - needs a prefManager');  return; }

  WILL_ge('buttonOK').focus();
  
  function _init() {
    this._newSourceCurrencyList = this.prefManager.getSourceCurrencyList();
    this._newTargetCurrencyList = this.prefManager.getTargetCurrencyList();
    this._completeList = this.prefManager.getCompleteCurrencyList(); //currently not shown, but could be modfied by chooser dialog

    //WILL_ge('chkbox_hideOriginal').checked = this.prefManager.getHideOriginalCurrency();
    //WILL_ge('tb_targetList').value         = this._newTargetCurrencyList;
    //WILL_ge('tb_sourceList').value         = this._newSourceCurrencyList;
    //WILL_ge('tb_debugLevel').value         = this.prefManager.getDebugLevel();
  }

  function guiDebugLevelChanged(tb_debugLevel) {
    //alert('changed '+tb_debugLevel);

    // WILL: this should probably only be done if you click on OK and not Cancel
    this.prefManager.setDebugLevel(tb_debugLevel.value); //rely on observer to update WILL_gDebug
  }

  function doButtonOK() {
    if (this._sourceListDirty) { this.prefManager.setSourceCurrencyList(this._newSourceCurrencyList); }
    if (this._targetListDirty) { this.prefManager.setTargetCurrencyList(this._newTargetCurrencyList); }
    window.close();
  }

  function doButtonCancel() {
    window.close();
    //WILL: TODO: warning if dirty
  }

  function doButtonResetAll() {
    this.prefManager.deleteViewMyCurrencyPrefs();
    this.prefManager.restoreOptionalPrefs(); //WILL: why do I expose both of these?
    this._init();
  }

  function doButtonDeletePrefs() {
    this.prefManager.deleteViewMyCurrencyPrefs();
    alert('VMC prefs deleted. Restart Firefox to get default prefs');
  }

  function doButtonModifyTargetList() {
    var returnVal={};
    var resetFunc    = this.prefManager.getDefaultTargetListPref;
    window.openDialog('chrome://viewmycurrency/content/WILL_TargetDialog.xul',
		      'WILL_TargetDialog',
		      'chrome,resizable,modal',
		      this._newTargetCurrencyList,this._completeList,resetFunc,returnVal);
    //WILL_dbg(returnVal);
    var newTargetList=returnVal['newSelectedCurrencyList'];
    //WILL: not doing anything with returnVal['newCompleteCurrencyList']
    if (newTargetList) {
      //alert('new target list');
      this._newTargetCurrencyList=newTargetList;
      this._targetListDirty=true;
      //WILL_ge('tb_targetList').value=newTargetList;

      this.exchangeRateCache.setSourceAndTargetLists(this._newSourceCurrencyList,this._newTargetCurrencyList);
      this._initTable(); //  update the tree view
    }

  }

  function doButtonModifySourceList() {
    var returnVal={};
    var resetFunc    = this.prefManager.getDefaultSourceListPref;

    window.openDialog('chrome://viewmycurrency/content/WILL_SourceDialog.xul',
		      'WILL_SourceDialog',
		      'chrome,resizable,modal',
		      this._newSourceCurrencyList,this._completeList,resetFunc,returnVal);
    //WILL_dbg(returnVal);
    var newSourceList=returnVal['newSelectedCurrencyList'];
    //WILL: not doing anything with returnVal['newCompleteCurrencyList']
    if (newSourceList) {
      //alert('new source list');
      this._newSourceCurrencyList=newSourceList;
      this._sourceListDirty = true;
      //WILL_ge('tb_sourceList').value=newSourceList;

      this.exchangeRateCache.setSourceAndTargetLists(this._newSourceCurrencyList,this._newTargetCurrencyList);
      this._initTable(); //  update the tree view
    }
  }




  function die() {
    this.exchangeRateCache.webUpdater.removeObserver(this);
  }

  function _initTable() {
    // var webserviceBox=WILL_ge('WILL_webservice_box');
//     var url=this.prefManager.getWebserviceUrl(1); //get the first (default) webservice
//     webserviceBox.appendItem(url);
//     webserviceBox.appendItem('http://localhost/FROM_CODE-TO_CODE');
//     webserviceBox.appendItem('http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency=FROM_CODE&ToCurrency=TO_CODE');
//     webserviceBox.selectedIndex=0; //select the first item


    var targets=this._newTargetCurrencyList.items;
    var treecols=WILL_ge('WILL_treecols');

    WILL_killChildren(treecols);
    
    var createCol = function(id,label) {
      var tc=document.createElement('treecol');
      tc.setAttribute('label',label);
      tc.setAttribute('id',   id);
      tc.setAttribute('flex', '1');
      treecols.appendChild(tc);
    };
    

    createCol('WILL_colSource','Source');
    for (var i=0; i<targets.length; i++) {
      createCol(targets[i].code,targets[i].toString()); //id, label
    }

    this.tree=WILL_ge('exchangeRates-tree');

    this.tree.view  = new WILL_ExchangeRatesTreeView(this.exchangeRateCache);

    var s=this.tree.view.selection;
    s.select = s.adjustSelection = s.selectAll = s.rangedSelect = s.toggleSelect = function() {};
    this.tree.view.selection=s;

    this.tree.addEventListener('click',function(e) { WILL_optionsManager.mouseClick(e); }, false);

    this._setTextBoxes( {'rate_tb':'', 'status_tb':'', 'source_tb':'', 'update_tb':'', 'err_tb':''} );

  }

  function buttonUpdate() {
    this._numRatesToUpdate=this.exchangeRateCache.updateFromWeb(true); //force update
    // this.observe() will be called automatically by the WebUpdater
  }


  function changeWebServiceUrl(menulist) {
    var newUrl=menulist.value;
    this.prefManager.setWebserviceUrl(1,newUrl); //set the first (default) webservice
    //WILL: should I do this now? or on OK or close?
  }

  function _setTextBoxes(text) {
    var tb;
    for (box in text) {
      tb = WILL_ge(box);
      tb.value=text[box];
    }

  }

  // only used here (to reduce event processing) (and to replay click)
  this.lastRowNum=null;
  this.lastColObj=null;

  function mouseClick(event)  {
    var rowObjHash = {}, colObjHash = {}, partObjHash = {};

    //    this.tree.view.selection.clearSelection();

    var treebox = this.tree.boxObject;
    treebox.QueryInterface(Components.interfaces.nsITreeBoxObject);
    treebox.getCellAt(event.clientX, event.clientY, rowObjHash, colObjHash, partObjHash);

    var colObj = colObjHash.value
    var rowNum = rowObjHash.value;

    if (this.lastRowNum==rowNum && this.lastColObj==colObj) { return; } //we already got this

    this._mouseClickOnCell(rowNum,colObj);
  }

  function _mouseClickOnCell(rowNum,colObj) { 
    var treebox = this.tree.boxObject;
    this.tree.view.performActionOnCell("WILLselect",rowNum,colObj);
    treebox.invalidateCell(this.lastRowNum,this.lastColObj); //undraw the old
    treebox.invalidateCell(rowNum,colObj); //draw the new selection

    this.lastRowNum=rowNum;
    this.lastColObj=colObj;
    

    if (!colObj) { return; }//WILL: when does this happen?
    if (rowNum<0 || rowNum>=this._newSourceCurrencyList.items.length) { return; }

    //left header column    
    //OR we don't bother with Exchange Rate objects for the obvious!
    
    var colName=WILL_toColName(colObj);
    var blank=false;
    if (colName=="WILL_colSource") { blank=true; }
    else {
      var targetCurr=this._newTargetCurrencyList.findFromCode(colName);
      var sourceCurr=this._newSourceCurrencyList.items[rowNum];
      if (sourceCurr.equals(targetCurr)) { blank=true; }
    }

    if (blank) {
      this._setTextBoxes( {'rate_tb':'', 'status_tb':'', 'source_tb':'', 'update_tb':'', 'err_tb':''} );
    } else {
      var exRate = this.exchangeRateCache.getRateObj(sourceCurr,targetCurr);
      var lastUpdate = exRate.getLastGoodUpdateTime();

      var text = {};

      text['rate_tb']   = exRate.toString();
      text['status_tb'] = exRate.status;
      text['source_tb'] = exRate.source;
      text['update_tb'] = lastUpdate || "Never updated";
      text['err_tb']    = exRate.lastUpdateErr ? exRate.lastUpdateErr : '';
      this._setTextBoxes( text );
    }
  }

  // observe an update in progress
  function observe(status) {
    var progressBar=WILL_ge('WILL_updateProgress');
    var progressPanel=WILL_ge('WILLstatusbar-progresspanel');
    var display=WILL_ge('WILLstatusbar-display');

    this._mouseClickOnCell(this.lastRowNum,this.lastColObj); //replay the last mouse click to update the details box. WILL: TODO: more elegant solution?
    var treebox = this.tree.boxObject;
    treebox.invalidate(); //redraw the entire tree

    if (status.substr(0,3)=="END") {
      //we are finished
      progressBar.value=100;
      window.setTimeout( function() {progressPanel.collapsed=true; treebox.invalidate();} , 500); //hide the panel and redraw the tree after half a sec
      display.label='Update complete';
    } else {
      var percentDone = 1 - this._webUpdater.fractionLeft();
      progressBar.value=percentDone*100;
      display.label='Updating '+this._webUpdater.numItemsToDo()+' exchange rates ...';
      progressPanel.collapsed=false; //show the panel
    }
  }


  function buttonDone() {
    if (!this.prefManager) {      WILL_alert('Could not save list - no main window');      return;    }

    //WILL TODO: say updating
    this.prefManager.setSourceCurrencyList(this.sourceList);

    //WILL: TODO: add watchers to do the update this.prefManager.exchangeRates.update();
    window.close();
  }
}


function WILL_toColName(colObj) {
  if (!colObj) { return undefined; } // WILL: who does this?
  var colName;
  if (typeof colObj == "string") {
    colName=colObj;
  } else { // it's a treeColumn object
    colName=colObj.id;
  }
  if (!colName) { WILL_log('ERR','invalid column'+colObj); }
  return colName;
}

function WILL_ExchangeRatesTreeView(exchangeRateCache) {
   var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
   this._exchangeRateCache=exchangeRateCache;
   this._sourceList=this._exchangeRateCache.sourceCurrencyList;
   this._targetList=this._exchangeRateCache.targetCurrencyList;
   this._willSelected=[null,null]; //the currently selected cell [row,col]
   this.rowCount = this._sourceList.items.length;

   this._findRateObj = function(row,colName) {
    if (row<0 || row>=this._sourceList.items.length) { return null; }//WILL: log?
    if (colName=='WILL_colSource') { return null; }
    var toCurrency=this._targetList.findFromCode(colName);
    var fromCurrency=this._sourceList.items[row];
    var rate=this._exchangeRateCache.getRateObj(fromCurrency,toCurrency);
    return rate;
   };

  this.getCellText = function(row,colObj){
    var colName=WILL_toColName(colObj);
    if (colName=='WILL_colSource') { return this._sourceList.items[row].toString(); }
    var rateObj = this._findRateObj(row,colName);
    if (!rateObj)   { return '';  }
    if (rateObj==1) { return '1'; }
    return rateObj.rate;
  };
  this.setTree = function(treebox){ this.treebox = treebox; };
  this.isEditable = function(index, colObj) { alert('h'); return false; };
  this.isContainer = function(row){ return false; };
  this.isSeparator = function(row){ return false; };
  this.isSorted = function(row){ return false; };
  this.getLevel = function(row){ return 0; };
  this.getImageSrc = function(row,colObj){ return null; };
  this.getRowProperties = function(row,props){};
  this.getCellProperties = function(row,colObj,props){
    var colName=WILL_toColName(colObj);
    if (this._willSelected[0]==row && this._willSelected[1]==colName) { props.AppendElement(aserv.getAtom("WILL_selected")); }
    var rateObj = this._findRateObj(row,colName);
    if (!rateObj || rateObj==1) { return; }
    if (rateObj.isStatusInvalid() )  { props.AppendElement(aserv.getAtom("WILL_rateInvalid"));      }
    if (rateObj.isStatusOld()     )  { props.AppendElement(aserv.getAtom("WILL_rateOld"));          }
    if (rateObj.lastUpdateErr     )  { props.AppendElement(aserv.getAtom("WILL_rateDownloadErr"));  }
  };

  this.getColumnProperties = function(colid,colObj,props){};
  this.getParentIndex = function(row) {return -1; };
  this.cycleHeader = function(colObj, elem) { };
  this.performAction = function(action) {
    alert('WILL: got action '+action);
    //assume update - I'm too lazy to calculate which row changed
    this.treebox.beginUpdateBatch();
    this.rowCount = this._sourceList.items.length;
    this.treebox.endUpdateBatch();
  };
  this.performActionOnCell = function(action, row, colObj ) {
    var colName=WILL_toColName(colObj);
    this._willSelected=[row,colName];
  };
}

