// $Id: WILL_PopupConvertToolbarManager.js,v 1.19 2006/01/06 12:06:34 Will Exp $


function WILL_PopupConvertToolbarManager(viewMyCurrency,range,originalFocus) {
  var self=this;
  this.viewMyCurrency=viewMyCurrency;
  this.range=range;
  this.nodes=null;
  
  this.insertHTMLmode = false; // do we write text back into the webpage?

  this._originalFocus = originalFocus; 
  this.guiUpdate=guiUpdate;
  this.guiUnload=guiUnload;
  this._init = _init;
  this._initTextBox = _initTextBox;
  this._getNewText = _getNewText;
  this._checkCurrency = _checkCurrency;
  this._fillCurrencyMenulist = _fillCurrencyMenulist;  

  this.toolbar=WILL_ge('WILL_popupConvert');
  this._tip=WILL_ge('WILL_tip');
  this._previousText=null; // a copy of oldTextBox.value to undo invalid user changes
  this._init();
  //WILL: TODO: Horrible textbox.value hack below:
  window.setTimeout( function() {self._initTextBox(self.newTextBox, self._getNewText());} ,1); //wait 1ms and then update the new textbox
  //this.guiUpdate();

  function _initTextBox(box,text) {
    //text = text.replace(/\s/g,' '); // covert all whitespace to spaces (don't show vertical tabs)
    var newlines = text.replace(/[^\n]/g,''); // remove everything other than newlines
    var rows = 1 + newlines.length ; // we start with one line, each new line adds a row

    if (rows==1) {
       box.setAttribute('multiline',false);
    } else {
      box.setAttribute('multiline',true);
      box.setAttribute('rows',rows-1);  //WILL: TODO: it seems stupid that rows attribute is how many extra rows. Not total number
    }

    //WILL: TODO: Get rid of this horrible hack. Without the timeout the value doesn't change in the DOM (but is does in JS!) if multiline changes!
    window.setTimeout( function() { box.value=text; } ,1); //wait 1ms and then update the textbox
    //box.value=text;
  }

  function onBrowserMouseDown() { self.guiUnload(); }

  function _init() {

    getBrowser().addEventListener("mousedown", onBrowserMouseDown, false); // hide the toolbar if we click outside it

    var selectedText='';

    if (this.range) { // it's possible there is no range if nothing has been selected, then the popup doesn't modify anything
      this.nodes   = HtmlConversion__getAllNodesInRange(this.range);
      selectedText = HtmlConversion__getTextOfNodes(this.nodes,this.range.startOffset,this.range.endOffset);
    }
    
    if (selectedText.length) {
      this.insertHTMLmode=true; // there is text to modify on the web page
    }
    
    this.fromCurrBox = WILL_ge('WILL_PopupFromCurr');
    this.toCurrBox   = WILL_ge('WILL_PopupToCurr');
    this.oldTextBox  = WILL_ge('WILL_PopupOldText');
    this.newTextBox  = WILL_ge('WILL_PopupNewText');

    this._initTextBox(this.oldTextBox,selectedText);
    this._previousText=selectedText; // make a copy of oldTextBox.value to undo invalid user changes

    this._fillCurrencyMenulist(this.fromCurrBox, this.viewMyCurrency.sourceCurrencyList, 'WILL_lastFromCurrencyCode');
    this._fillCurrencyMenulist(this.toCurrBox,   this.viewMyCurrency.targetCurrencyList, 'WILL_lastToCurrencyCode');


    this.toolbar.hidden=false;


    //give text box the focus but don't select all text - too easy to destroy exisiting text
    var delayedFunc = function() {
      var oldTextBox = WILL_ge('WILL_PopupOldText');
	oldTextBox.setSelectionRange(0,0); 
      oldTextBox.focus();
    };

    window.setTimeout( delayedFunc ,1); //wait 1ms and then update the textbox
  }

  // rebuild menulist from scratch - it's possible currency list has changed
  // place the last used option on top
  function _fillCurrencyMenulist(currencyBox,currencyList,lastAttribute) {
    currencyBox.removeAllItems();
    var lastCurr=this.toolbar.getAttribute(lastAttribute);

    if (lastCurr) { currencyBox.appendItem(lastCurr); }

    var currencies=currencyList.items;
    for (var i=0;i<currencies.length;i++) {
      if (lastCurr != currencies[i].code) {
	currencyBox.appendItem(currencies[i].code);
      }
    }
    if (lastCurr != 'XXX') { currencyBox.appendItem('XXX'); } // no currency is always be an option
    currencyBox.selectedIndex=0; //select the 1st item (the remembered one)
  }


  // called on every keystroke and mouseclick
  //fromCurrBox is the SOURCE currency
  function guiUpdate(message,event) {
    var newText;
    var oldTextBox = this.oldTextBox;
    if (message=='onkeyup') {
      if (event.keyCode == event.DOM_VK_ESCAPE) {
	this.guiUnload();
	return;
      } else if (event.keyCode == event.DOM_VK_RETURN && event.ctrlKey === false && event.shiftKey === false ) {
	// return was pressed without Shift or Control
	newText = this.newTextBox.value;
	if (this.insertHTMLmode) {
	  WILL_log('INFO','saving text: ['+newText+']');
	  HtmlConversion__setTextOfNodes(this.nodes,newText,this.range.startOffset,this.range.endOffset, true /*forceUpdateEmpty*/ );
	}
	this.guiUnload();
	return;
      }
    }

    if (message=='input') {
      //WILL_log('DBG','previous = '+this._previousText+'\nCurrent = '+oldTextBox.value);
      var previousMarkerCount = HtmlConversion_countMarkerChars(this._previousText);
      var currentMarkerCount  = HtmlConversion_countMarkerChars(oldTextBox.value);
      if (currentMarkerCount != previousMarkerCount) { // did the user delete special markers?
	var selectionEnd = oldTextBox.selectionEnd;
	var selectionStart = oldTextBox.selectionStart;
	oldTextBox.value=this._previousText; // undo the users change.
	oldTextBox.setSelectionRange(selectionStart,selectionEnd);
	return;
      }
      this._previousText=oldTextBox.value; // make a copy of oldTextBox.value to undo invalid user changes
    }
    
    //WILL: FUTURE: Escape pressed anywhere should close (not just oldTextBox)
    //WILL: FUTURE: when the focus is in one of the listboxes but the popup list isn't displayed then return should update and close the toolbar

    //WILL_log('INFO',message+' event='+event);
    
    // convert the old text into new text by doing currency conversion on any numbers that appear
    this.newTextBox.value=this._getNewText();
  
  }

  function _getNewText() {
    var oldText = this.oldTextBox.value;    
    try {
      var newText=null;
      // create tooltip and throw exception if the source and target aren't valid
      var targetCurrency = this._checkCurrency(this.viewMyCurrency.targetCurrencyList, this.toCurrBox);
      if (targetCurrency) {
	var sourceCurrencyList=this.viewMyCurrency.sourceCurrencyList;
	var sourceCurrency = this._checkCurrency(sourceCurrencyList, this.fromCurrBox); 
	
	var getRateFunc = this.viewMyCurrency.getRateFunc;
	newText = WILL_CurrencyConvertStr(oldText,targetCurrency, sourceCurrencyList, getRateFunc,  this.viewMyCurrency.hideOriginalCurrency,
					  sourceCurrency );
      }
      if (!newText) {
	//WILL: normally this is an error, but it can also happen if nothing changed throw "conversion error"; 
	newText=oldText;
      }


      //       this.newBox.setAttribute('style','color:green;');
      
      //WILL: TODO: only hide if visiable - causes exeptions
      this._tip.hidePopup();
    } catch (error) {
      WILL_log('DBG',error);
      
    }
    return newText;
  }
  

  function _checkCurrency(currencyList,currencyBox) {
    var currencyCode = currencyBox.value;
    if (currencyCode=='XXX') { return null; }

    var currency=currencyList.findFromStr(currencyCode, true/*silentFailure*/);
    //if (sourceCurrency.equals(targetCurrency)) { throw "Source == target"; }
    if (!currency) {
      //WILL: TODO: make a different tool tip ??
      var errorMsg = 'Invalid currency symbol';
      // highlight in red if invalid
      this._tip.firstChild.value=errorMsg;
      this._tip.showPopup(currencyBox,-1,-1,"tooltip","topleft","bottomleft");
      //this._setText(this.newBox,'error');
      //this.newBox.setAttribute('style','color:red;');

      throw errorMsg;
    }
    return currency;
  }



  function guiUnload() {
    //alert('unloading');
    getBrowser().removeEventListener("mousedown", onBrowserMouseDown, false);
    this.toolbar.setAttribute('WILL_lastFromCurrencyCode',this.fromCurrBox.value);
    this.toolbar.setAttribute('WILL_lastToCurrencyCode',  this.toCurrBox.value);
    this.toolbar.hidden=true;
    if (this._originalFocus) { this._originalFocus.focus(); } // restore the original focus
  }

}
