// $Id: WILL_ViewMyCurrency.js,v 1.22 2006/01/10 23:18:06 Will Exp $

var WILL_popupConvertManager;
function WILL_ViewMyCurrency(gui) {
  var self=this;
  var LEFT=1;
  var RIGHT=2;

  this.gui  = gui;
  this._initFromPrefs                = _initFromPrefs;
  this.onDOMContentLoaded           = onDOMContentLoaded;
  this.setTargetCurrency            = setTargetCurrency;
  this.toggleHideOriginal           = toggleHideOriginal;

  this.processFrame = processFrame;
  this.updateBrowsers               = updateBrowsers;
  this.die                          = die;
  this.getRateFunc  = null; // pointer to exhangeRateCache.getRate
  this.watchDebugLevel              = watchDebugLevel;
  this.watchHideOriginal            = watchHideOriginal;
  this.watchTargetList              = watchTargetList;
  this.watchSourceList              = watchSourceList;
  this.observe = observe;

  this._unrecognisedCurrencies = {};

  this._initFireFox = _initFireFox;
  this._doDelayedStartup = _doDelayedStartup;
  this._doDelayedInstall = _doDelayedInstall;

  this._initFireFox();
  this.prefManager   = new WILL_PrefManager();
  WILL_gDebug=this.prefManager.getDebugLevel();
  this.updateGuiCallback = function() { WILL_alert('null callback - ViewMyCurrencyGui did not initialise'); }; 

  this._installStatus = this.prefManager.doStartupChecks(true); // auto-cancel dialogs
  WILL_log('INFO','Install status: '+ this._installStatus);

  this._init = _init;

  this.gui.registerViewMyCurrency(this);

  switch(this._installStatus) {
  case "ALREADY_INSTALLED": //normal case
    this._init();
    this.callwrapper = new CCallWrapper(this, 5*60*1000, '_doDelayedStartup'); //after 5min delay call this._doDelayedStartup(null) to update exchange rates
    CCallWrapper.asyncExecute(this.callwrapper);
    //window.setTimeout(this.,3000); //wait 3s for firefox to finish GUI and then update any old exchange rates
    break;
  case "TO_INSTALL": // all prefs missing
    this.callwrapper = new CCallWrapper(this, 3000, '_doDelayedInstall'); 
    CCallWrapper.asyncExecute(this.callwrapper);
    break;
  case "DONT_INSTALL":
    break; //do nothing
  default:
    WILL_alert('unknown install status :'+this._installStatus);
  }

  function _doDelayedInstall() {

    var configOK = this.prefManager.doFirstTimeSetup();

    if (configOK) {
      this._installStatus="ALREADY_INSTALLED";
      this._init();
      this._doDelayedStartup();
      this.setTargetCurrency(this.prefManager.getTargetCurrency());
    } else {
      this._installStatus="DONT_INSTALL";
    }
  }

  function _initFireFox() {
    //get the tabbrowser  OR get the mini-browser if we are in test mode (true = don't complain on failure)
    var appcontent = WILL_ge("appcontent",true) || WILL_ge('WILL_miniBroswer',true);
    if (!appcontent) {
      WILL_alert('Could not find appcontent - is ViewMyCurrency running in Firefox?');
      return;
    }
    appcontent.addEventListener("DOMContentLoaded", function(e) { self.onDOMContentLoaded.call(self,e);       }, false);

  }

  function _doDelayedStartup() {
    WILL_log('DBG','Doing delayed startup');
    this.exchangeRateCache.updateFromWeb(); //try to update any old or missing rates

    //WILL: TODO: updates are now only on application startup - this should be periodic check
  }

  function observe(status) {
    if (status == 'END_OK') {
      // the exchange rates have been successfully updated, now we update the current web pages
      this.updateBrowsers();
    }
  }

  function _init() {

    this._initFromPrefs(); //setup  this.sourceCurrencyList,  this.targetCurrencyList, this.targetCurrency
    var exCache = new WILL_ExchangeRateCache(this.prefManager.readRate, this.prefManager.writeRate, this.prefManager.getWebserviceUrl,
					     this.sourceCurrencyList, this.targetCurrencyList);
    this.exchangeRateCache = exCache;
    this.getRateFunc = function(from,to) { return exCache.getRate(from,to); }; //WILL: is this really cleaner than just exposing the whole cache object


    this.prefManager.watchDebugLevel(   this,'watchDebugLevel'   );
    this.prefManager.watchTargetList(   this,'watchTargetList'   );
    this.prefManager.watchSourceList(   this,'watchSourceList'   );
    this.prefManager.watchHideOriginal( this,'watchHideOriginal' );
  
    this.exchangeRateCache.webUpdater.addObserver(this.gui);
    this.exchangeRateCache.webUpdater.addObserver(this);

    // The initial page doesn't cause a load event so update manually  
    if (this.targetCurrency)  { this.updateBrowsers(); }
  }

  function watchHideOriginal() {
    this.hideOriginalCurrency  = this.prefManager.getHideOriginalCurrency();
    this.updateGuiCallback();
    if (this.targetCurrency) { // only need to redraw pages if we are currency converting
      this.updateBrowsers();
    }
  }

  function watchDebugLevel() {
    WILL_gDebug=this.prefManager.getDebugLevel();  
    WILL_log('DBG','Watching debug level go to '+WILL_gDebug);
  }
  function watchTargetList() {
    WILL_log('DBG','View my Currency: target currency list changed');
    this.targetCurrencyList         = this.prefManager.getTargetCurrencyList();
    //WILL: TODO: need to update exchange rates - but should we do it here or wait for express command?
    this.exchangeRateCache.setSourceAndTargetLists(this.sourceCurrencyList,this.targetCurrencyList);
    this.exchangeRateCache.updateFromWeb();

    //WILL: we can't set the target currency (which redoes the page) until we've updated the rates. 
    //update the target currency - if it's not on the list anymore, go back to null.
    this.setTargetCurrency(this.prefManager.getTargetCurrency());
  }
  function watchSourceList() {
    WILL_log('DBG','View my Currency: source currency list changed');
    this.sourceCurrencyList         = this.prefManager.getSourceCurrencyList();
    //WILL: TODO: need to update exchange rates
    this.exchangeRateCache.setSourceAndTargetLists(this.sourceCurrencyList,this.targetCurrencyList);
    this.exchangeRateCache.updateFromWeb();
  }



  //////////////
  function die() {
    //////////////
    // we got an unload event
    if (this._installStatus!="ALREADY_INSTALLED")  { return; }


    if (CCallWrapper.mPendingCalls.length) {
      this.callwrapper.cancel();
    } else {
      this.exchangeRateCache.webUpdater.removeObserver(this);
      this.exchangeRateCache.webUpdater.removeObserver(this.gui);
    }
    this.prefManager.removeWatcher('watchDebugLevel');
    this.prefManager.removeWatcher('watchTargetList');
    this.prefManager.removeWatcher('watchSourceList');
    this.prefManager.removeWatcher('watchHideOriginal' );

    //alert('died');
  }
  /////////////////////
  function _initFromPrefs() {
    ///////////////////
    
    // quick sanity check
    var missingPrefs=this.prefManager.missingRequiredPrefs();
    if (missingPrefs) { WILL_alert(  'The following preferences are missing:\n'+missingPrefs+  '\n\nThe startup check should have prevented this'); }

    // update object
    this.sourceCurrencyList          = this.prefManager.getSourceCurrencyList();
    this.targetCurrencyList         = this.prefManager.getTargetCurrencyList();
    //WILL: do I need the complete list somewhere?
    this.targetCurrency             = this.prefManager.getTargetCurrency(); //null is allowed --> disabled
    this.hideOriginalCurrency       = this.prefManager.getHideOriginalCurrency();
    //WILL: if I change a list, don't I need to update the cache?
  }

  function toggleHideOriginal() {
    this.hideOriginalCurrency = ! this.hideOriginalCurrency;
    this.prefManager.setHideOriginalCurrency(this.hideOriginalCurrency);
    //watchHideOriginal will take care of updating browsers
  }

  //update the target currency - if it's not on the list go to disabled
  function setTargetCurrency(newTargetCurrency) {
    var newTarget=null;
    if (newTargetCurrency) {
      if (this.targetCurrencyList.existsInList(newTargetCurrency)) { newTarget=newTargetCurrency; }
    }

    this.targetCurrency=newTarget;
    this.prefManager.setTargetCurrency(newTarget);
    this.updateGuiCallback();
    this.updateBrowsers();
  }

  function updateBrowsers() {
    this.processFrame(top);
  }

  function processFrame(f) {
    if (!f) {return; }
    WILL_log('DBG','Processing frame '+f+' location='+f.location);
    
    if (f != top) { // don't modify the browser itself!
      if (this.targetCurrency) {
	//force active pages to update since we just changed the target //WILL: CHECK is this force
	HtmlConversion_changePageToTargetCurrencyUsingNodes(f.document, this.targetCurrency, this.hideOriginalCurrency, this.sourceCurrencyList, this.getRateFunc); 
      } else {
	HtmlConversion_restorePage(f.document);
      }
    }
    
    for (var i=0;i<f.frames.length; i++) {
      this.processFrame(f.frames[i]);
    }
  }


  // happens every time I load a page

  ////////////////////////
  function onDOMContentLoaded(e) {
    ////////////////////////
    var startTime=new Date();

    var document = e.originalTarget;
    if (!document.body) { WILL_log('WARN','Doucment.body is null - why?'); }
    //if (!document.body.innerHTML) return; 
 
    WILL_log('INFO','Loaded URL='+document.URL);

    this.updateGuiCallback();
 
    if (this.targetCurrency) {
      HtmlConversion_changePageToTargetCurrencyUsingNodes(document, this.targetCurrency, this.hideOriginalCurrency, this.sourceCurrencyList, this.getRateFunc);
    }

    var endTime=new Date();
    WILL_log('INFO','Extra delay due to me was '+ (endTime-startTime) + 'ms');
  }  

}
