// $Id: WILL_ViewMyCurrencyGui.js,v 1.22 2006/01/10 23:18:06 Will Exp $

/////////////////////
// ** GUI STUFF ** //
/////////////////////

function WILL_ViewMyCurrencyGui() {
  var self = this;
  var LABEL_POPUP_CONVERT='ViewMyCurrency: ';

  this._viewMyCurrency=null; //set by register func

  this.registerViewMyCurrency      = registerViewMyCurrency;
  this.doContentMenuPopup          = doContentMenuPopup;
  this.doDisableTarget             = doDisableTarget;
  this.doHideSource                = doHideSource;
  this.doNextTarget                = doNextTarget;
  this.doToggleConvert             = doToggleConvert;
  this.doUpdateStatus              = doUpdateStatus;
  this.doStatusbarpanelClicked     = doStatusbarpanelClicked;
  this.doContextMenu               = doContextMenu;
  this.doOpenOptionsDialog         = doOpenOptionsDialog;
  this.doTest                      = doTest;
  this.doPopupConvert              = doPopupConvert;
  this.observe = observe;

  this._init = _init;
  this.die   = die;

  this._init();

  function _init() {
    var statusbarpanel = WILL_ge("WILL_statusbarpanel");
    var menu           = WILL_ge("contentAreaContextMenu");
    
    menu.addEventListener("popupshowing",           function(e) { self.doContentMenuPopup.call(self,e);      }, false);
    statusbarpanel.addEventListener("mousedown",    function(e) { self.doStatusbarpanelClicked.call(self,e); }, false);
    statusbarpanel.contextMenu="WILL_statusIconPopup2";
    
    //W: this._viewMyCurrency.gui = self;


  }

  // let the object that does all the work register with this GUI object
  function registerViewMyCurrency(viewMyCurrency) {
    this._viewMyCurrency = viewMyCurrency;
    this._viewMyCurrency.updateGuiCallback = function() { self.doUpdateStatus(); };
    this.doUpdateStatus(); // draw the inital gui
  };

  function die() {
    this._viewMyCurrency.die();
  }

  function doToggleConvert() {
    var newTarget=this._viewMyCurrency.targetCurrencyList.getNext(this._viewMyCurrency.targetCurrency);
    this._viewMyCurrency.setTargetCurrency(newTarget);
    this.doUpdateStatus();
  }

  function doNextTarget() {
    var newTarget=this._viewMyCurrency.targetCurrencyList.getNext(this._viewMyCurrency.targetCurrency);
    this._viewMyCurrency.setTargetCurrency(newTarget);
  }

  function doDisableTarget() {
    this._viewMyCurrency.setTargetCurrency(null);
  }
  
  function doHideSource() {
    this._viewMyCurrency.toggleHideOriginal();
    this.doUpdateStatus();
  }

  /////////////////////////////
  function doStatusbarpanelClicked (event) {
    /////////////////////////////
    switch(this._viewMyCurrency._installStatus) {
    case "ALREADY_INSTALLED": //normal case
      if (event.button !== 0) { return; } //WILL: This wasn't a left-click so do nothing here (right-click brings up menu). TODO: test on mac and unix
      this.doNextTarget();
      break;
    case "TO_INSTALL":
      // all the preferences are missing, but it won't hurt to check again
      // break; NB - falls through!
    case "DONT_INSTALL":
      var status=this._viewMyCurrency.prefManager.doStartupChecks(false); //don't auto-cancel
      if (status=="TO_INSTALL") {
	this._viewMyCurrency._doDelayedInstall();
      }
      break;
    default:
      WILL_alert('unknown install status :'+this._viewMyCurrency._installStatus);
    }
  }

  ////////////////////////
  function doUpdateStatus () {
    //////////////////////

    var statusbarpanel = WILL_ge("WILL_statusbarpanel");

    var hide=this._viewMyCurrency.hideOriginalCurrency;
    WILL_ge('WILL_hideOriginal').setAttribute('checked',hide);
    WILL_ge('WILL_hideOriginal2').setAttribute('checked',hide);

    var targetSet = (this._viewMyCurrency.targetCurrency != null);
    WILL_ge('WILL_toggleConvert').setAttribute('checked',targetSet);
    WILL_ge('WILL_toggleConvert2').setAttribute('checked',targetSet);

    var label;
    var tooltiptext;
    var curr=this._viewMyCurrency.targetCurrency;
    if (!curr) {
      label="XXX";
      tooltiptext="Not converting currencies. Click to change";
    } else {
      label=curr.code+' '+curr.getHtml();
      tooltiptext='Converting to '+curr.toString();
    }
    statusbarpanel.label=label;
    statusbarpanel.setAttribute('tooltiptext',tooltiptext);
    var style=''; //go back to default style
    statusbarpanel.setAttribute('style',style);
    return;
  }

  // used to observe the WebUpdater
  function observe(status) {
    var statusbarpanel = WILL_ge("WILL_statusbarpanel");    
    var style;
    var tooltiptext;

    switch(status) {

    case 'START':
      style='color:blue;';
      tooltiptext='Getting the latest exchange rates from web';
      break;

    case 'END_ERRORS':
      style='color:red;';
      tooltiptext='Failed to download all exchange rates';
      this._viewMyCurrency.updateBrowsers();
      break;

    case 'END_OK':
      style=' '; //reset to default style (single space forces an update)
      tooltiptext='Downloaded exhange rates OK';
      break;

    case 'RATE_ERROR':
      style='color:darkred;';
      tooltiptext='Failed to download all exchange rates (still in progress)';
      break;

    case 'RATE_UPDATED':
      // do nothing
      break;

    default:
      WILL_alert('got unknown webupdate status ['+status+']');
    } //end switch

    if (style)       { statusbarpanel.setAttribute('style',style);             }
    if (tooltiptext) { statusbarpanel.setAttribute('tooltiptext',tooltiptext); }
  }



  // the user right-clicked inside the broswer. Now we decided if we should we add our menuitem
  function doContentMenuPopup(event) {
    var menuitem;
    var showPopupConvert;
    var seltext;

    var sel=gContextMenu.searchSelected(100);
    if (sel) {
      seltext = sel.toString();
      showPopupConvert=true;
    }
    menuitem = WILL_ge('WILL_contentMenuitemP');
    if (showPopupConvert) {
      menuitem.label=LABEL_POPUP_CONVERT+' "'+WILL_shortenStr(seltext,16)+'"';
      menuitem.hidden=false;
    } else {
      menuitem.hidden=true;
    }

    //WILL: TODO: consider seperator and order of menuitems
  }


  // helper func
  function _getSelectedTextRange() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var selectionObj = focusedWindow.getSelection();      
    if (!selectionObj.rangeCount)  { return null; }
    if (selectionObj.rangeCount>1) { WILL_alert('warning selection rangeCount is '+selectionObj.rangeCount+' only looking at first item'); }
    return selectionObj.getRangeAt(0);
  }


  // the user click on our menuitem in either the right-click context menu of the browser, our statusbar, our tools menu or pressed keyboard shortcut
  function doPopupConvert() {
    // run the popup converter
    var range=_getSelectedTextRange();
    var focus = document.commandDispatcher.focusedWindow; // so we can restore focus when we hide the toolbar
    WILL_popupConvertManager = new WILL_PopupConvertToolbarManager(this._viewMyCurrency,range,focus);
  }
    

  function doContextMenu(menuitem) {
    
    if (menuitem.label.substr(0,LABEL_POPUP_CONVERT.length) != LABEL_POPUP_CONVERT) {
      WILL_log('ERR','Unknown menuitem '+menuitem.label);
      return;
    }

    this.doPopupConvert();

  }
  
  function doOpenOptionsDialog() {
    window.openDialog('chrome://viewmycurrency/content/WILL_OptionsDialog.xul','WILL_OptionsDialog','chrome,resizable,modal');
  }
 
  
  function doTest() {
    alert('test');
  }
}
